//
// output binary of garmin protocol
//
#define DEBUGREAD	 0
//=================================================
//  typedefs from the Garmin Protocol Specification
//=================================================
typedef unsigned char byte;
typedef unsigned long longword;
typedef unsigned char boolean;
typedef unsigned char BYTE;

extern int timeonsa3;
#define MAX_LENGTH	255	/* maximum length of Garmin binary message */
#if __BORLANDC__
//================================================================
//================================================================
// Borland compiler
//================================================================
//================================================================
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <alloc.h>
#include <bios.h>
#include <conio.h>
#include <dir.h>
#include <dos.h>
#include <fcntl.h>
#include <io.h>
#include <math.h>
#include <mem.h>
#include <signal.h>
#include <time.h>
#include <ctype.h>

#define INT int
#define LONGdouble long double
#define WORD	short
#define	DWORD	long
#define LONG	long
#define MAXTRACK 	4096

INT AsyncInit(INT addr, INT irq);
unsigned INT AsyncStat(void);  
void AsyncSet(INT Baud, INT Control);
void AsyncOut(INT dev);
void AsyncStop(INT IOAddress);
extern struct 	ftime ft;

#if 0
typedef struct tagRGBQUAD { 		// rgbq 
	BYTE    rgbBlue;
	BYTE    rgbGreen; 
	BYTE    rgbRed;
	BYTE    rgbReserved;
} RGBQUAD; 

typedef struct tagBITMAPFILEHEADER {// bmfh
	WORD    bfType; 				// specifies file type--must be BM
	DWORD   bfSize; 				// size in bytes of the bitmap file
	WORD    bfReserved1; 			// must be 0
	WORD    bfReserved2;			// must be 0
	DWORD   bfOffBits;				// offset in bytes from the BITMAPFILEHEADER to the 
									//  bitmap bits
} BITMAPFILEHEADER;

typedef struct tagBITMAPINFOHEADER{ // bmih
	DWORD  biSize; 					// Specifies the number of bytes required by the structure
	LONG   biWidth;					// Specifies the width of the bitmap, in pixels
	LONG   biHeight;				// Specifies the height of the bitmap, in pixels
	WORD   biPlanes;				// Specifies the number of planes for the target device. 
									//  This value must be set to 1. 
	WORD   biBitCount; 				// Specifies the number of bits per pixel.
									//  This value must be 1, 4, 8, 16, 24, or 32. 
	DWORD  biCompression;			// Specifies the type of compression for a compressed
	                                //  bottom-up bitmap (top-down DIBs cannot be compressed). 
									//  It can be one of the following values:
//		  Value			Description 
// 		BI_RGB			An uncompressed format. 
// 		BI_RLE8			A run-length encoded (RLE) format for
//						bitmaps with 8 bits per pixel.  The
//						compression format is a two-byte format
//						consisting of a count byte followed by a byte
//						containing a color index.  For more
//						information, see the following Remarks section.
//		BI_RLE4  		An RLE format for bitmaps with 4 bits per pixel.  The
//						compression format is a two-byte format
//						consisting of a count byte followed by two
//						word-length color indices.  For more
//						information, see the following Remarks section.

// 		BI_BITFIELDS    Specifies that the bitmap is not compressed and that the
//						color table consists of three doubleword color masks that
//						specify the red, green, and blue components, respectively, of
//						each pixel.  This is valid when used with 16- and
//						32-bits-per-pixel bitmaps.

		DWORD  biSizeImage;			// Specifies the size, in bytes, of the image.
									//  This may be set to 0 for BI_RGB bitmaps
		LONG   biXPelsPerMeter;		// Specifies the horizontal resolution, in pixels per meter,
									//  of the target device for the bitmap. An application can
									//  use this value to select a bitmap from a resource group
									//  that best matches the characteristics of the current
									//  device
		LONG   biYPelsPerMeter;		// Specifies the vertical resolution, in pixels per meter,
									//  of the target device for the bitmap
		DWORD  biClrUsed;			// Specifies the number of color indices in the color table
									//  that are actually used by the bitmap. If this value is
									//  zero, the bitmap uses the maximum number of colors
									//  corresponding to the value of the biBitCount member for
									//  the compression mode specified by biCompression
		DWORD  biClrImportant; 		// Specifies the number of color indices that are consideredi
									//  important for displaying the bitmap.
									//  If this value is zero, all colors are important
} BITMAPINFOHEADER; 

typedef struct tagBITMAPINFO {		// bmi
	BITMAPINFOHEADER bmiHeader; 	// Specifies a BITMAPINFOHEADER structure that contains
									//  information about the dimensions and color format
									//  of a DIB. 
	RGBQUAD  bmiColors[1];			// Specifies an array of RGBQUAD or doubleword data
									//  types that define the colors in the bitmap
} BITMAPINFO;
#endif
#else					// not borland compiler
//================================================================
//================================================================
// Visual C++ 5.0 compiler
//================================================================
//================================================================
#define INT short
extern struct	mftime ft;
void AsyncOut(unsigned char *buf, INT count);
void AsyncSet(int wBaudRate, INT wByteSize, INT wStopBits, INT wParity);
INT AsyncInit(char *a);
void AsyncStop(void);
#define MAXTRACK 	65535L
#define LONGdouble double
#ifdef unix
#include <limits.h>
#define _MAX_PATH PATH_MAX
#define _timeb timeb
#define _ftime ftime
#define _stat stat
#define _fstat fstat
#define stricmp strcasecmp
#define strncmpi strncasecmp
#define strnicmp strncasecmp
#define min(a,b) ((a) <= (b) ? (a) : (b))
#define max(a,b) ((a) >= (b) ? (a) : (b))
char *strupr(char *str);
char *strlwr(char *str);
#else
void	Catcher(unsigned dd);
#include <WINDOWS.H>
#include <conio.h>
#include <dos.h>
#include <io.h>
#define fnsplit _splitpath
#define strncmpi _strnicmp
#define stricmp _stricmp
#endif
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <fcntl.h>
#include <math.h>
#include <signal.h>
#include <time.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <sys/timeb.h>
#define M_PI        3.14159265358979323846
struct  mftime   {
    unsigned int   ft_tsec  : 5;   // Two second interval
    unsigned int   ft_min   : 6;   // Minutes
    unsigned int   ft_hour  : 5;   // Hours
    unsigned int   ft_day   : 5;   // Days
    unsigned int   ft_month : 4;   // Months
    unsigned int   ft_year  : 7;   // Year
};
extern void delay(long);
extern void conson(void);
extern void consoff(void);
#endif

extern  char ProgramName[MAX_LENGTH];
typedef INT Symbol_Type;
typedef unsigned INT word;
//=======================================
//  typedefs for bitmaps
//=======================================

#define ASY_MAX 4 
#define TIMEOUT 3 // seconds to wait for response from serial port
#define RADtoDEG  57.295779513082322
#define DEGtoRAD  0.017453292519943296

INT kbraw(void);
INT AsyncIn(void);

void AsyncSend(BYTE * message, INT length);
INT AsyncOutStat(void);
INT AsyncInStat(void);

#define COM1 0
#define COM2 1
#define COM3 2
#define COM4 3

#define Pi (double)M_PI

extern	INT route_lines;
extern	int cycle_track_colors;
extern	char months[13][4];
extern	char days[7][4];
extern	char debugin_name[MAX_LENGTH];
/* Messages declarations */
extern	BYTE m1[],     m2[];
extern	BYTE p1[],     p2[];
extern	BYTE alm1[],   alm2[];
extern	BYTE trk1[],   trk2[];
extern	BYTE wpt1[],   wpt2[];
extern	BYTE rte1[],   rte2[],     rte3[];
extern	BYTE almt[],   rtet[],     trkt[],   wptt[];
extern	BYTE pwroff[], GPStimex[], GPSPos[], HDWare[];

struct RECORD {
	char type;			// Record Type W,T,R,D,P
	char ident[41];		// Record ident
	char ns;			//  N/S for latitude
	double la;			// latitude   in dd.ddddddd
	char ew;			//  E/W for longitude
	double lo;			// longitude  in dd.ddddddd
	INT monthn;			// month number of record
	char day_week[4];	// day of week of record
	char datetime[25];	// date/time string as read
	INT dayofmonth;		// day of month 1-31
	INT year;			// 4 digit year of record
	INT ht,mt,st;		// time of record
	INT dla, mla;		// Deg & Min for Lat
	INT dlo, mlo;		// Deg & Min for Long
	INT tnthsla, tnthslo;	// tenths of a minute*10000
	double minla,minlo;	// Lat/Long minutes in decimal
	double secla,seclo;	// Lat/Long seconds in decimal
	float ProxDist;		// Proximity Distance
	short icon_smbl; 	// Garmin smbl coverted to SA
	short icon_dspl;	// Display style.  Consistant with
						//  later garminunits, i.e.
						//
						//  1 = Symbol by itself
						//  2 = Symbol with waypoint name
						//  3 = Symbol with comment

    BYTE color;         //  Waypoint symbol Color for Color units:
                        //
                        //   12CX : 0 - Default waypoint color
                        //          1 - Red
                        //          2 - Green
                        //          3 - Blue
//
// garmin additions from beta.  They are used by various Pilot units
//
	BYTE class;
	BYTE status;		// for Lowrance/Eagle waypoints
	BYTE subclass[13];
	INT alt;
	INT dpth;
	char state[3];
	char cc[3];			// garmin
	char name[31];		// garmin
	char comment[51];   // Comment field 20 max for 45
	char facility[31];  // facility name
	char city[25];      // garmin (24)
	char addr[51];      // address
	char cross_road[51];// intersecting road label
	float altitude;
};

extern struct RECORD record;
struct PREFS{
	short datum;
	long creator;
	double offset;
};
extern struct PREFS gPrefs;

// Garmin message type characters
#define ACK			0x06	// last record received was ok
#define ALM 		0x1f	// Almanac record
#define EOFREC  	0x0c	// EOF leadin for transters
#define GPSpos		0x11	// GPS Position record
#define PROX		0x13	// GPS Proximity Position record
#define MYID		0xff	// Version/ID record
#define NAK			0x15	// last record received was bad
#define NREC		0x1b	// number of records to receive
#define RTE_NAM 	0x1d	// Route name record
#define RTE_WPT 	0x1e	// Route waypoint record
#define TIMEREC 	0x0e	// UTC Time record
#define TRK 		0x22	// Track record
#define WPT 		0x23	// Waypoint record
#define Volts 		0x28	// GPS Voltages record
#define SENDID 		0xfe	// Send ID

/* Defines for Com Port Paramaters, the second paramater to AsyncSet() */
#define BITS_8      0x03
#define BITS_7      0x02
#define STOP_1      0x00
#define STOP_2      0x04
#define EVEN_PARITY 0x18
#define ODD_PARITY  0x08
#define NO_PARITY   0x00

/* Defines for AsyncHand() */
#define	DTR			0x01
#define	RTS			0x02
#define	USER		0x04
#define	LOOPBACK	0x10

/* Defines for AsyncStat() */
#define	D_CTS		0x0100
#define	D_DSR		0x0200
#define	D_RI		0x0400
#define	D_DCD		0x0800
#define	CTS			0x1000
#define	DSR			0x2000
#define	RI			0x4000
#define	DCD			0x8000
#define	PARITY		0x0004
#define	THREMPTY	0x0020
#define	BREAKDET	0x1000

//=======================================
//
// Structures for waypoint records
//
//=======================================

typedef struct
{
	INT product_ID;
	INT software_version;
	byte a[1];  // fake the below by....
// char product_description[]; null-terminated string
// ... zero or more additional null-terminated strings
} Product_Data_Type;

typedef struct
{
	byte tag;
	word data;
} Protocol_Data_Type;

typedef struct
{
	long lat; /* latitude in semicircles */
	long lon; /* longitude in semicircles */
} Semicircle_Type;

//
//  7.5.1. D100_Wpt_Type
typedef struct
{
	char ident[6];			// identifier
	Semicircle_Type posn;	// position
	unsigned long unused;	// should be set to zero
	char cmnt[40];			// comment
} D100_Wpt_Type;

//  7.5.2. D101_Wpt_Type
//
// Example products: GPSMAP 210 and GPSMAP 220 (both prior to version 4.00).
typedef struct
{
	char ident[6];			// identifier
	Semicircle_Type posn;	// position
	longword unused;		// should be set to zero
	char cmnt[40];			// comment
	float dst;				// proximity distance (meters)
	byte smbl;				// symbol id
} D101_Wpt_Type;

//The enumerated values for the "smbl" member of the D101_Wpt_Type
//   are the same as those for Symbol_Type (see Section 7.4.9 on page 28).
//   However, since the "smbl" member of the D101_Wpt_Type is only 8-bits
//   (instead of 16-bits), all Symbol_Type values whose upper byte is
//   non-zero are unallowed in the D101_Wpt_Type.
//7.5.3. D102_Wpt_Type
//
// Example products: GPSMAP 175, GPSMAP 210 and GPSMAP 220.
typedef struct
{
	char ident[6];			// identifier
	Semicircle_Type posn;	// position
	longword unused;		// should be set to zero
	char cmnt[40];			// comment
	float dst;				// proximity distance (meters)
	Symbol_Type smbl;		// symbol id
} D102_Wpt_Type;

//7.5.4. D103_Wpt_Type
// Example products: GPS 12, GPS 12 XL, GPS 48 and GPS II Plus.
typedef struct
{
	char ident[6];			// identifier
	Semicircle_Type posn;	// position
	longword unused;		// should be set to zero
	char cmnt[40];			// comment
	byte smbl;				// symbol id
	byte dspl;				// display option
} D103_Wpt_Type;
// The enumerated values for the "dspl" member of the D103_Wpt_Type
//    are shown below:
//enum
//{
//	dspl_name = 0, /* Display symbol with waypoint name */
//	dspl_none = 1, /* Display symbol by itself */
//	dspl_cmnt = 2 /* Display symbol with comment */
//};

//7.5.5. D104_Wpt_Type
// Example products: GPS III.
typedef struct
{
	char ident[6];			// identifier
	Semicircle_Type posn;	// position
	longword unused;		// should be set to zero
	char cmnt[40];			// comment
	float dst;				// proximity distance (meters)
	Symbol_Type smbl;		// symbol id
	byte dspl;				// display option
} D104_Wpt_Type;
// The enumerated values for the "dspl" member of the 
//   D104_Wpt_Type are shown below:
//enum
//{
//	dspl_smbl_only = 1, /* Display symbol by itself */
//	dspl_smbl_name = 3, /* Display symbol with waypoint name */
//	dspl_smbl_cmnt = 5, /* Display symbol with comment */
//};

// 7.5.6. D105_Wpt_Type
typedef struct
{
	Semicircle_Type posn;	// position
	Symbol_Type smbl;		// symbol id
	char wpt_ident[1]; 		// null-terminated string -- length isn't
	                        //   really specified, I added 1 for a place
							//   holder for the decode of D105 waypoints
} D105_Wpt_Type;

// 7.5.7. D106_Wpt_Type
//  Example products: StreetPilot (route waypoints).
typedef struct
{
	byte class;				// class
	byte subclass[13];		// subclass
	Semicircle_Type posn;	// position
	Symbol_Type smbl;		// symbol id
	char wpt_ident[1];  	// null-terminated string -- length isn't
	                        //   really specified, I added 10 for a place
							//   holder for the decode of D106 waypoints
/* char lnk_ident[]; null-terminated string */
} D106_Wpt_Type;
// The enumerated values for the "class" member of the D106_Wpt_Type
//   are as follows:
//	Zero:     indicates a user waypoint ("subclass" is ignored).
//	Non-zero: indicates a non-user waypoint ("subclass" must be valid).
//
//  For non-user waypoints (such as a city in the GPS map database), the
//	GPS will provide a non-zero value in the "class" member, and the
//	"subclass" member will contain valid data to further identify
//	the non-user waypoint.  If the Host wishes to transfer this
//	waypoint back to the GPS (as part of a route), the Host must
//	leave the "class" and "subclass" members unmodified.
//
//	For user waypoints, the Host must ensure that the "class" member
//	is zero, but the "subclass" member will be ignored and should be
//	set to zero.
//	
//	The "lnk_ident" member provides a string that indicates the name
//	of the path from this waypoint to the next waypoint in the
//	route.
//	
//	For example, "HIGHWAY 101" might be placed in "lnk_ident" to
//	show that the path from this waypoint to the next waypoint is
//	along Highway 101.  The "lnk_ident" string may be empty (i.e.,
//	no characters other than the null terminator), which indicates
//	that no particular path is specified.
//

typedef struct
{
	char 			ident[6];	// identifier
	Semicircle_Type posn;		// position
	longword 		unused;		// should be set to zero
	char 			cmnt[40];	// comment
	byte 			smbl;		// symbol id
	byte 			dspl;		// display option
	float 			dst;		// proximity distance (meters)
	byte 			color;		// waypoint color
} D107_Wpt_Type;
//  The enumerated values for the "smbl" member of the D107_Wpt_Type are the
//  same as the the "smbl" member of the D103_Wpt_Type.
//
//  The enumerated values for the "dspl" member of the D107_Wpt_Type are
//  shown below are the same as the the "dspl" member of the D103_Wpt_Type.
//  
//  The enumerated values for the "color" member of the D107_Wpt_Type are
//  shown below:
//  
//enum
//{
//	clr_default = 0,	// Default waypoint color
//	clr_red = 1,		// Red
//	clr_green = 2,		// Green
//	clr_blue = 3		// Blue
//};

// D108_Wpt_Type
//  Example products: eMap
typedef struct 														// size
{
	byte			wpt_class; 		// class (see below) 				1
	byte			color; 			// color (see below) 				1 
	byte			dspl; 			// display options (see below) 		1
	byte			attr; 			// attributes (see below) 			1
	Symbol_Type		smbl; 			// waypoint symbol 					2
	byte			subclass[18]; 	// subclass 						18
	Semicircle_Type	posn; 			// 32 bit semicircle 				8
	float 			alt; 			// altitude in meters 				4
	float 			dpth; 			// depth in meters 					4
	float 			dist; 			// proximity distance in meters		4
	char 			state[2]; 		// state 							2
	char 			cc[2]; 			// country code 					2
	char 			ident[51]; 		//	variable length string 			1-51
// char 			comment[]; 			waypoint user comment 			1-51
// char 			facility[]; 		facility name 					1-31
// char 			city[]; 			city name 						1-25
// char 			addr[]; 			address number 					1-51
// char 			cross_road[]; 		intersecting road label 		1-51
} D108_Wpt_Type;

//enum
//{
//	USER_WPT =      0x00, // User waypoint
//	AVTN_APT_WPT =  0x40, // Aviation Airport waypoint
//	AVTN_INT_WPT =  0x41, // Aviation Intersection waypoint
//	AVTN_NDB_WPT =  0x42, // Aviation NDB waypoint
//	AVTN_VOR_WPT =  0x43, // Aviation VOR waypoint
//	AVTN_ARWY_WPT = 0x44, // Aviation Airport Runway waypoint
//	AVTN_AINT_WPT = 0x45, // Aviation Airport Intersection
//	AVTN_ANDB_WPT = 0x46, // Aviation Airport NDB waypoint
//	MAP_PNT_WPT =   0x80, // Map Point waypoint
//	MAP_AREA_WPT =  0x81, // Map Area waypoint
//	MAP_INT_WPT =   0x82, // Map Intersection waypoint
//	MAP_ADRS_WPT =  0x83, // Map Address waypoint
//	MAP_LABEL_WPT = 0x84, // Map Label Waypoint
//	MAP_LINE_WPT =  0x85, // Map Line Waypoint
//};

//The "color" member can be one of the following values:
//enum {	Black, 
//		Dark_Red, 
//		Dark_Green, 
//		Dark_Yellow,
//		Dark_Blue, 
//		Dark_Magenta, 
//		Dark_Cyan, 
//		Light_Gray,
//		Dark_Gray, 
//		Red, 
//		Green, 
//		Yellow,
//		Blue, 
//		Magenta, 
//		Cyan, 
//		White,
//		Default_Color = 0xFF
//};

// The enumerated values for the "dspl" member of the D108_Wpt_Type are the
//     same as the the "dspl" member of the D103_Wpt_Type.

// The "attr" member should be set to a value of 0x60.

// The "subclass" member of the D108_Wpt_Type is used for map waypoints
//   only, and should be set to 0x0000 0x00000000 0xFFFFFFFF 0xFFFFFFFF
//   0xFFFFFFFF for other classes of waypoints.

// The "alt" and "dpth" members may or may not be supported on a given
//    unit.  A value of 1.0e25 in either of these fields indicates that this
//    parameter is not supported or is unknown for this waypoint.



//7.5.8. D150_Wpt_Type
//  Example products: GPS 150, GPS 155, GNC 250 and GNC 300.
typedef struct
{
	char ident[6];			// identifier
	char cc[2];				// country code
	byte class;				// class
	Semicircle_Type posn;	// position
	INT alt;				// altitude (meters)
	char city[24];			// city
	char state[2];			// state
	char name[30];			// facility name
	char cmnt[40];			// comment
} D150_Wpt_Type;
//	The enumerated values for the "class" member of the D150_Wpt_Type 
//     are shown below:
//enum
//{
//	apt_wpt_class = 0, /* airport waypoint class */
//	int_wpt_class = 1, /* intersection waypoint class */
//	ndb_wpt_class = 2, /* NDB waypoint class */
//	vor_wpt_class = 3, /* VOR waypoint class */
//	usr_wpt_class = 4, /* user defined waypoint class */
//	rwy_wpt_class = 5, /* airport runway threshold waypoint class */
//	aint_wpt_class = 6 /* airport intersection waypoint class */
//};
//	The "city," "state," "name," and "cc"members are invalid when the
//   "class" member is equal to usr_wpt_class. The "alt" member is valid
//   only when the "class" member is equal to apt_wpt_class.

//7.5.9. D151_Wpt_Type
// Example products: GPS 55 AVD, GPS 89.
typedef struct
{
	char ident[6];			// identifier
	Semicircle_Type posn;	// position */
	longword unused;		// should be set to zero */
	char cmnt[40];			// comment */
	float dst;				// proximity distance (meters) */
	char name[30];			// facility name */
	char city[24];			// city */
	char state[2];			// state */
	INT alt;				// altitude (meters) */
	char cc[2];				// country code */
	char unused2;			// should be set to zero */
	byte class;				// class */
} D151_Wpt_Type;
//  The enumerated values for the "class" member of the D151_Wpt_Type
//    are shown below:
//enum
//{
//	apt_wpt_class = 0, /* airport waypoint class */
//	vor_wpt_class = 1, /* VOR waypoint class */
//	usr_wpt_class = 2 /* user defined waypoint class */
//};
// 	The "city," "state," "name," and "cc"members are invalid when
//  the "class" member is equal to usr_wpt_class.  The "alt" member is valid
//  only when the "class" member is equal to apt_wpt_class.

//7.5.10. D152_Wpt_Type
//  Example products: GPS 90, GPS 95 AVD, GPS 95 XL and GPSCOM 190.
typedef struct
{
	char ident[6];			// identifier
	Semicircle_Type posn;	// position
	longword unused;		// should be set to zero
	char cmnt[40];			// comment
	float dst;				// proximity distance (meters)
	char name[30];			// facility name
	char city[24];			// city
	char state[2];			// state
	INT alt;				// altitude (meters)
	char cc[2];				// country code
	char unused2;			// should be set to zero
	byte class;				// class
} D152_Wpt_Type;
//	The enumerated values for the "class" member of the D152_Wpt_Type
//    are shown below:
//enum
//{
//	apt_wpt_class = 0, /* airport waypoint class */
//	int_wpt_class = 1, /* intersection waypoint class */
//	ndb_wpt_class = 2, /* NDB waypoint class */
//	vor_wpt_class = 3, /* VOR waypoint class */
//	usr_wpt_class = 4 /* user defined waypoint class */
//};
// The "city," "state," "name," and "cc"members are invalid when the
// "class" member is equal to usr_wpt_class.  The "alt" member is valid
// only when the "class" member is equal to apt_wpt_class.

//7.5.11. D154_Wpt_Type
//Example products: GPSMAP 195.
typedef struct
{
	char ident[6];			// identifier 
	Semicircle_Type posn;	// position 
	longword unused;		// should be set to zero 
	char cmnt[40];			// comment 
	float dst;				// proximity distance (meters) 
	char name[30];			// facility name 
	char city[24];			// city 
	char state[2];			// state 
	INT alt;				// altitude (meters) 
	char cc[2];				// country code 
	char unused2;			// should be set to zero 
	byte class;				// class 
	Symbol_Type smbl;		// symbol id
} D154_Wpt_Type;
// The enumerated values for the "class" member of the D154_Wpt_Type are
// shown below:
//enum
//{
//	apt_wpt_class = 0, /* airport waypoint class */
//	int_wpt_class = 1, /* intersection waypoint class */
//	ndb_wpt_class = 2, /* NDB waypoint class */
//	vor_wpt_class = 3, /* VOR waypoint class */
//	usr_wpt_class = 4, /* user defined waypoint class */
//	rwy_wpt_class = 5, /* airport runway threshold waypoint class */
//	aint_wpt_class = 6, /* airport intersection waypoint class */
//	andb_wpt_class = 7, /* airport NDB waypoint class */
//	sym_wpt_class = 8 /* user defined symbol-only waypoint class */
//};
// The "city," "state," "name," and "cc"members are invalid when the
// "class" member is equal to usr_wpt_class or sym_wpt_class.  The "alt"
// member is valid only when the "class" member is equal to apt_wpt_class.

//7.5.12. D155_Wpt_Type
// Example products: GPS III Pilot.
typedef struct
{
	char ident[6];			// identifier 
	Semicircle_Type posn;	// position 
	longword unused;		// should be set to zero 
	char cmnt[40];			// comment 
	float dst;				// proximity distance (meters) 
	char name[30];			// facility name 
	char city[24];			// city 
	char state[2];			// state 
	INT alt;				// altitude (meters) 
	char cc[2];				// country code 
	char unused2;			// should be set to zero 
	byte class;				// class 
	Symbol_Type smbl;		// symbol id 
	byte dspl;				// display option 
} D155_Wpt_Type;
// The enumerated values for the "dspl" member of the D155_Wpt_Type are
// shown below:
//enum
//{
//	dspl_smbl_only = 1, /* Display symbol by itself */
//	dspl_smbl_name = 3, /* Display symbol with waypoint name */
//	dspl_smbl_cmnt = 5, /* Display symbol with comment */
//};
// The enumerated values for the "class" member of the D155_Wpt_Type are
// shown below:
//enum
//{
//	apt_wpt_class = 0, /* airport waypoint class */
//	int_wpt_class = 1, /* intersection waypoint class */
//	ndb_wpt_class = 2, /* NDB waypoint class */
//	vor_wpt_class = 3, /* VOR waypoint class */
//	usr_wpt_class = 4 /* user defined waypoint class */
//};
// The "city," "state," "name," and "cc"members are invalid when the
// "class" member is equal to usr_wpt_class.  The "alt" member is valid
// only when the "class" member is equal to apt_wpt_class.

//=====================================================================
typedef struct
{
	double lat; // latitude in radians
	double lon; // longitude in radians
} Radian_Type;

//7.5.13. D200_Rte_Hdr_Type
// Example products: GPS 55 and GPS 55 AVD.
typedef byte D200_Rte_Hdr_Type; // route number

//7.5.14. D201_Rte_Hdr_Type
// Example products: all products unless otherwise noted.
typedef struct
{
	byte nmbr; 			// route number
	char cmnt[20]; 		// comment
} D201_Rte_Hdr_Type;

//7.5.15. D202_Rte_Hdr_Type
// Example products: StreetPilot.
typedef struct
{
	char rte_ident[1];
/* char rte_ident[]; null-terminated string */
} D202_Rte_Hdr_Type;

//7.5.16. D300_Trk_Point_Type
// Example products: all products unless otherwise noted.
typedef struct
{
	Semicircle_Type posn;	// position
	longword time;			// time
	boolean new_trk;		// new track segment?
} D300_Trk_Point_Type;
//The "time" member provides a timestamp for the track log point.  This
// time is expressed as the number of seconds since 12:00 AM on January 1st,
// 1990.  When true, the "new_trk" member indicates that the track log
// point marks the beginning of a new track log segment.
typedef struct
{
    Semicircle_Type posn;   // position
    longword time;          // time */
    float alt;              // altitude in meters
    float dpth;             // depth in meters
    boolean new_trk;        // new track segment?
} D301_Trk_Point_Type;
//
// The "time" member provides a timestamp for the track log point.  This
// time is expressed as the number of seconds since UTC 12:00 AM on
// December 31 st , 1989.
//
// The `alt' and `dpth' members may or may not be supported on a given
// unit.  A value of 1.0e25 in either of these fields indicates that this
// parameter is not supported or is unknown for this track point.
//
// When true, the "new_trk" member indicates that the track log point marks
// the beginning of a new track log segment.
//

typedef struct
{
    boolean dspl;           // display on the map?
    byte color;             // color (same as D108)
    char trk_ident[51];     // beginning of a string of *up to* 51 chars including the end NULL, but
                            //  the structure length is sizeof(boolean)+sizeof(byte)+strlen(trk_ident)+1
/* char trk_ident[];        // null-terminated string */
} D310_Trk_Hdr_Type;
// The ` trk_ident' member has a maximum length of 51 characters
//  including the terminating NULL.


//7.5.17. D400_Prx_Wpt_Type
// Example products: GPS 55, GPS 55 AVD, GPS 75 and GPS 95 AVD.
typedef struct
{
	D100_Wpt_Type wpt;	// waypoint
	float dst;			// proximity distance (meters)
} D400_Prx_Wpt_Type;

//7.5.18. D403_Prx_Wpt_Type
// Example products: GPS 12, GPS 12 XL and GPS 48.
typedef struct
{
	D103_Wpt_Type wpt;	// waypoint
	float dst;			// proximity distance (meters) 
} D403_Prx_Wpt_Type;

//7.5.19. D450_Prx_Wpt_Type
// Example products: GPS 150, GPS 155, GNC 250 and GNC 300.
typedef struct
{
	INT idx;			// proximity index
	D150_Wpt_Type wpt;	// waypoint
	float dst;			// proximity distance (meters)
} D450_Prx_Wpt_Type;

//7.5.20. D500_Almanac_Type
// Example products: GPS 38, GPS 40, GPS 45, GPS 55, GPS 75, GPS 95 and GPS II.
typedef struct
{
	INT wn;				// week number (weeks) 
	float toa;			// almanac data reference time (s) 
	float af0;			// clock correction coefficient (s) 
	float af1;			// clock correction coefficient (s/s) 
	float e;			// eccentricity (-) 
	float sqrta;		// square root of semi-major axis (a) (m**1/2) 
	float m0;			// mean anomaly at reference time (r) 
	float w;			// argument of perigee (r) 
	float omg0;			// right ascension (r) 
	float odot;			// rate of right ascension (r/s) 
	float i;			// inclination angle (r) 
} D500_Almanac_Type;

//7.5.21. D501_Almanac_Type
// Example products: GPS 12, GPS 12 XL, GPS 48, GPS II Plus and GPS III.
typedef struct
{
	INT wn;				// week number (weeks) 
	float toa;			// almanac data reference time (s) 
	float af0;			// clock correction coefficient (s) 
	float af1;			// clock correction coefficient (s/s) 
	float e;			// eccentricity (-) 
	float sqrta;		// square root of semi-major axis (a) (m**1/2) 
	float m0;			// mean anomaly at reference time (r) 
	float w;			// argument of perigee (r) 
	float omg0;			// right ascension (r) 
	float odot;			// rate of right ascension (r/s) 
	float i;			// inclination angle (r) 
	byte hlth;			// almanac health bits 17:24 (coded) 
} D501_Almanac_Type;

typedef char svid_type;
//7.5.22. D550_Almanac_Type
// Example products: GPS 150, GPS 155, GNC 250 and GNC 300.
typedef struct
{
	svid_type svid;		// satellite id 
	INT wn;				// week number (weeks) 
	float toa;			// almanac data reference time (s) 
	float af0;			// clock correction coefficient (s) 
	float af1;			// clock correction coefficient (s/s) 
	float e;			// eccentricity (-) 
	float sqrta;		// square root of semi-major axis (a) (m**1/2) 
	float m0;			// mean anomaly at reference time (r) 
	float w;			// argument of perigee (r) 
	float omg0;			// right ascension (r) 
	float odot;			// rate of right ascension (r/s) 
	float i;			// inclination angle (r) 
} D550_Almanac_Type;
// The "svid" member identifies a satellite in the GPS constellation as
// follows:  PRN-01 through PRN-32 are indicated by "svid" equal to 0
// through 31, respectively.

//7.5.23. D551_Almanac_Type
// Example products: GPS 150 XL, GPS 155 XL, GNC 250 XL and GNC 300 XL.
typedef struct
{
	svid_type svid;		// satellite id 
	INT wn;				// week number (weeks) 
	float toa;			// almanac data reference time (s) 
	float af0;			// clock correction coefficient (s) 
	float af1;			// clock correction coefficient (s/s) 
	float e;			// eccentricity (-) 
	float sqrta;		// square root of semi-major axis (a) (m**1/2) 
	float m0;			// mean anomaly at reference time (r) 
	float w;			// argument of perigee (r) 
	float omg0;			// right ascension (r) 
	float odot;			// rate of right ascension (r/s) 
	float i;			// inclination angle (r) 
	byte hlth;			// almanac health bits 17:24 (coded) 
} D551_Almanac_Type;
// The "svid" member identifies a satellite in the GPS constellation as
// follows:  PRN-01 through PRN-32 are indicated by "svid" equal to 0
// through 31, respectively.

//7.5.24. D600_Date_Time_Type
// Example products: all products unless otherwise noted.
typedef struct
{
	byte month;			// month (1-12) 
	byte day;			// day (1-31) 
	word year;			// year (1990 means 1990) 
	INT hour;			// hour (0-23) 
	byte minute;		// minute (0-59) 
	byte second;		// second (0-59) 
} D600_Date_Time_Type;
// The D600_Date_Time_Type contains the UTC date and UTC time.

//7.5.25. D700_Position_Type
// Example products: all products unless otherwise noted.
typedef Radian_Type D700_Position_Type;

//7.5.26. D800_Pvt_Data_Type
// Example products: all products unless otherwise noted.
typedef struct
{
	float alt;			// altitude above WGS 84 ellipsoid (meters) 
	float epe;			// estimated position error, 2 sigma (meters) 
	float eph;			// epe, but horizontal only (meters) 
	float epv;			// epe, but vertical only (meters) 
	INT fix;			// type of position fix 
	double tow;			// time of week (seconds) 
	Radian_Type posn;	// latitude and longitude (radians) 
	float east;			// velocity east (meters/second) 
	float north;		// velocity north (meters/second) 
	float up;			// velocity up (meters/second) 
	float msl_hght;		// height of WGS 84 ellipsoid above MSL (meters) 
	INT leap_scnds;		// difference between GPS and UTC (seconds) 
	long wn_days;		// week number days 
} D800_Pvt_Data_Type;
//=========================================
//=== End of typedefs from Garmin Beta doc
//=========================================

//=========================================
//
// functions
//
//=========================================
void 	push_route(void);
void 	push_icon(void);
void 	push_track(void);
void 	push_waypoint(void);
void 	push_proximity(void);
void 	push_record(char *in, INT convert);
void	Usage(INT i);
void	Usageh0(void);
void	UsagehD(void);
void	UsagehI(void);
void	UsagehO(void);
void	byebye(INT rt);
void	calc_sa_items(void);
INT		checksum(unsigned char *m,INT l);
void	chk_cmdline(void);
void	set_sign(void);
void	set_ns(void);
void	clear_route_dupes(void);
void	clean_proximity(void);
void 	count_tracks(void);
void 	count_routes(void);
INT		comment_len(void);
void	convert_g64(unsigned char *in);
INT		convert_from_GPS(INT ict);
INT		convert_to_12xl(INT ict);
INT		convert_from_12xl(INT ict);
void	datumconv(double la, double lo);
long	date2days(short mm, short dd, short yy);
void	days2date(long days, short *mm, short *dd, short *yy);
void	datetime2record(char *d);
void	decode_COM(char *b);
INT		decode_month(char *s);
void	decode_route_start(unsigned char *ix);
void	DegToUTM(double lat, double lon, char *zone, double *x, double *y);
INT		determine_input(char *fname_in);
double	distance(double a,double b,double c,double d);
void	doAlmanac(void);
void	doD100(D100_Wpt_Type *a);
void 	doD105(D105_Wpt_Type *a);
void 	doD106(D106_Wpt_Type *a);
void 	doD150(D150_Wpt_Type *a);
void	doDisplay(void);
void	doEOFRec(void);
void	doProtocolArray(void);
void	doPVT(void);
void	doGPSPos(void);
void	doID(void);
void	domagmaxmin(char *in);
void	doRouteName(void);
void	doSAlmanac500(void);
void	doSRouteHdr(void);
void	doSTrack(void);
void	doSWaypoint(INT Prox);
void	doTime(void);
void	doSTime(void);
void	doTrack(void);
void	doGPSVolts(void);
void	doWaypoint(INT typ);
void	doProxWaypoint(void);
void	do_command(unsigned char *b);
void	do_input(INT i);
void	do_pushed_route(void);
void	do_sa3_merge(void);
void	doasystat(void);
INT		dow( INT day, INT mon, INT year );
long	dt2secs(short offset);
void	fill_icon(int i,unsigned char * j, INT convert);
void	fill_record_from_text(unsigned char *ix,INT convert);
void	fill_track(int ele,INT convert);
void	fill_waypoint_from_push(int i,int j, int convert);
void	fixname(INT j,unsigned char *name);
double	fm_diskLL(unsigned long l);
INT 	from_sa3object(BYTE val);
void	getAlmanac(void);
void	getGarminDisplay(void);
void	getGarminMessage(INT e);
void	getGPSPosition(void);
void	getGPSVolts(void);
void	getGPSTime(void);
void	getGPSrecords(void);
void	getGPSstart(unsigned char *m, INT c, char *msg);
void	getID(void);
void	GetLowrDisplay(void);
void	getRoute(void);
char	*getstrings(char *source, char *separators, INT a );
void	getTrack(void);
void	getProtocolArray(void);
void	getProxWaypoints(void);
void	getPVT(void);
void	getWaypoints(void);
INT		get_model(void);
INT		getopt(INT argc, char **argv, char *opts);
INT		htoi(char *s);
void	initialize(void);
INT		instr(char *src,char *pat);
void	light_sleep(char onoff);
char *  ltrim(char *s);
int	main(INT argc, char **argv);
void	make_bin(char *i,INT r);
double	mhr(char * tt);
void	msdelay(unsigned INT milliseconds);
void	navSRouteS(void);
void	navSWaypoint(void);
char *  null_newline(char *s);
void	open_COM(INT rcvr);
void	openit(char *b);
void	read_OZI_evt(void);
void	read_OZI_trk(void);
void	read_OZI_rte(void);
void	read_OZI_owp(void);
void	read_OZI_plt(void);
void	read_OZI_wpt(void);
void	read_FUGAWI_trk(void);
void	read_FUGAWI_wpt(void);
void	read_GPL(void);
INT		open_output(char *mode);
void	oomem(char *s);
void	out_sa3_m(void);
void	out_sa3_s(void);
void	out_sa3_t(void);
void	output_CSV(void);
void	output_IGC_trk(void);
void	output_OZI_evt(void);
void	output_OZI_trk(void);
void	output_OZI_plt(void);
void	output_OZI_wpt(void);
void	output_OZI_owp(void);
void	output_OZI_rte(void);
void	output_FUGAWI_trk(void);
void	output_FUGAWI_wpt(void);
void	output_g45(void);
void	output_g64(void);
void	output_GPL(void);
void	output_nav(void);
void	output_sa3(void);
void	output_sa3hdr(void);
void	output_sa4(void);
void	output_sa4_route0(void);
void	output_text(void);
void	outsa4_cir(void);
void	outsa4_trk(void);
void	output_UTM(void);
void	output_wpt2trk(void);
void	outsa4_area(void);
void	out_sa_route(INT i,INT j);
void	parseGPS(void);
void	poweroff(void);
void	printArray(void);
void	light_on(void);
void	light_off(void);
void	prhex(unsigned char *message,INT c);
void	print_csv_i(void);
void	print_csv_w(void);
void	print_csv_t(void);
void	print_datums(void);
void	print_g64_t(void);
void	print_g64_w(void);
void	print_icons(void);
void	print_routes(void);
void	print_text_w(void);
void 	print_waypoints(INT i,INT j);
void 	print_tracks(void);
void	print_protocols(void);
void	process_g45_in(void);
void	push_files(char *b);
void 	push_icon(void);
void 	push_proximity(void);
void 	push_record(char *in,INT convert);
void 	push_route(void);
void 	push_route_point(INT r, INT p);
void 	push_track(void);
void 	push_waypoint(void);
void	readMapNote(FILE *in);
void	readMapLine(FILE *in);
void	readMapArea(FILE *in);
void	readMapCircle(FILE *in);
void	readMapSymbol(FILE *in);
void	readMapText(FILE *in);
void	read_nav_route(void);
void	read_sa3(FILE *in);
INT		read_sa3_header(FILE *in, char* fname_in);
void	read_text(void);
char *  rtrim(char *s);
void	sa3out(unsigned char *s);
void	sa3out_w(void);
void	sa4out(unsigned char *s);
void	sa4out_t(void);
void	sa4out_th(INT i);
char *  secs2dt(long secs, short offset);
void	SendGarminMessage(BYTE *message, short bytes,char *m);
void	send_g45_routes(void);
void	send_num_points(int num, char *a);
void	set_align(char *arg);
void	set_circle_parms(void);
void	set_color(char *arg);
void	set_contrast(void);
void	set_datetime(void);
void 	set_datum(char *from, char * to);
void	set_params(void);
void	set_record_icon(void);
void	set_symbol_parms(void);
void	set_size(char *arg);
void	set_line_parms(INT lt);
void	setProtocolParams(void);
void	settime_record(time_t dot);
void	sortit(char **a, int *items);
void	stopPVT(void);
void	strip_chars(char *s);
void	strip_tr_0(char *s);
char	*strtok3(char *source, char *separators );
unsigned long to_diskLL(double l);
BYTE	to_sa3object(INT val);
char *  toDMlat(double a);
char *  toDMlon(double a);
char *  trim(char *s);
double  toDegrees(long a);
long	toSemiCircles(double b);
int		wpt_in_route(char *wpt, int rt);
void	UTMtoDeg(short zone, short southernHemisphere, double x, double y, double *lat, double *lon);
//
// Lowr.c routines
//
void	DoLowrWPT(void);
BYTE	SetLowrChkSum(BYTE * a, INT len);
BYTE	ChkLowrChkSum(BYTE * s, INT l);
void	SendLowrMessage(INT command, BYTE *message, INT bytes, char *msgtype);
void	GetLowrMessage(INT exit_on_error);
double	round(double n, int dig);
long 	atDegtoMM(double d);
double	LatMMtoDeg(long m);
long	LongDegtoMM(double d);
double	LongMMtoDeg(long m);
void	LowrParse(void);
void	OutputLowr(void);
void	GetLowrTrack(INT i);
void	GetLowrTrackMem(INT i);
void	GetLowrWpts(void);
void	GetLowrRts(void);
void	GetLowrIcons(void);
void	GetLowrID(void);
void	GetLowrGPSDisplay(void);
long	LatDegtoMM(double d);
INT		convert_to_Lowr(INT i);
INT		convert_from_Lowr(INT i);
void	DoLowrPlotTrailOrigin(void);

#define PROCX
#define DISABLE			0
#define ENABLE			1
#define ChkFree(a)		if((a)!=NULL)free(a)
#if __BORLANDC__
#define MAXWAYP 	 751
#else
#define MAXWAYP 	 65500
#endif
#define MAXROUTES 	  99
#define MAXPOINTS 	  99
#define MAXICON   	1001
#define MAXPROX 	  10
#define NORMAL_WP 	   0
#define NORMAL_WP_1    1
#define PROX_WP 	   6
#define ROUTE_1_WP	   8
#define ROUTE_WP	   9
#define NOFILE		-2  // file not found
#define UNKNOWN		 0  // Unknown file type
#define TEXT_IO		 1	// text/gd7
#define GARMIN		 2	// GPS i/o
#define SA3			 3	// Street Atlas 3
#define ALMANAC_D	 4	// Almanac data
#define NAVROUTE 	 5	// Navigate route
#define SA4          6	// Street Atlas 4
#define SA5          7	// Street Atlas 5
#define SA_GPL		 8  // Street Atlas GPL files
#define SA6          9	// Street Atlas 6
#define FUGAWI_WPT	10	// Fugawi waypoint file
#define FUGAWI_TRK	11	// Fugawi track file
#define OZI_EVT		12	// OziExplorer events (Icons)
#define LOWRANCE	15	// GPS i/o
#define OZI_PLT		16	// OziExplorer track file
#define OZI_WPT		17	// OziExplorer waypoint file
#define OZI_RTE		18	// OziExplorer route file
#define NONE		 0
#define SA_SYMBOL	 1
#define SA_TRACK	 2
#define SA_CIRCLE	 3

#define TRACKS		 1
#define WAYPOINTS	 2
#define ROUTES		 3
#define ID			 4
#define TIME		 5
#define POSITION	 6
#define ALMANAC		 7
#define PROXIMITY	 8
#define VOLTAGES 	 9
#define PVT			12
#define PPROTOCOLS	14
#define GERROR		99
#define LOWRERROR	99

#define TRACK1 		1
#define TRACK2 		2
#define LWRWPTS 	3
#define LWRRTS 		4
#define LWRICONS	5
#define LWRID		6
#define START		2447892L	// Julian date for 00:00 12/31/1989
#define STARTLOWR	2448623L 	// Julian date for 00:00 01/01/1992 
#define GARMIN_BAUD_RATE	9600
#define LOWR_BAUD_RATE		115200L
#define	COM_SETTINGS	(BITS_8 | STOP_1 | NO_PARITY)
#define NOPARITY            0
#define ODDPARITY           1
#define EVENPARITY          2
#define MARKPARITY          3
#define SPACEPARITY         4
#define ONESTOPBIT          0
#define ONE5STOPBITS        1
#define TWOSTOPBITS         2
#define BYTESIZE			8

extern INT datatype;

extern INT LwrStartPt;				// Set to # in LEI unit where waypoint upload is to start.
extern INT LwrRangeLo;				// If retrieving a range of waypoints from a LEI unit this
                                    //  is the start waypoint #
extern INT LwrRangeHi;				// If retrieving a range of waypoints from a LEI unit this
                                    //  is the finish waypoint #

extern INT D105orD106;				// 1 if current waypoint is to/from a D105 or D106 record

extern INT	Product_ID;				// 72  GPS III  	... 
extern INT	Product_Ver;			// 000 - all		...

extern INT ProductDataProtocol;     // 000 - A000		A000  ALL GPS's support this

extern INT PhysicalProtocol;		// 000 - P000		P000

extern INT	LinkProtocol;			// 001 = L001		L001,L002

extern INT	CommandProtocol;		// 010 = A010		A010,A011

extern INT	WaypXferProtocol;		// 100 = A100		A100
extern INT	WaypDataRecord;			// 104 = D104		D100,D101,D102,D103,D104,D105,D106,D150
									//					D151,D152,D154,D155

extern INT RouteXferProtocol;		// 200 = A200		A200
extern INT RouteHdrType;			// 201 = D201		D200,D201,D202
extern INT	RouteDataRecord;		// 104 = D104		D100,D101,D102,D103,D104,D105,D106,D150
									//					D151,D152,D154,D155

extern INT TrackXferProtocol;		// 300 = A300		A300
extern INT	TrackDataRecord;		// 300 = D300		D300

extern INT ProxXferProtocol;		//  -1 = None		A400
extern INT	ProxDataRecord;			//  -1 = None		D101,D102,D152,D400,D403,D450


extern INT	AlmanacXferProtocol;	// 500 = A500		A500
extern INT AlmanacDataRecord;		// 501 = D501		D500,D501,D550,D551

extern INT UTCXferProtocol;			// 600 = A600		A600
extern INT UTCDataRecord;			// 600 = D600		D600

extern INT	PositionXferProtocol;	// 700 = A700		A700
extern INT PositionDataRecord;		// 700 = D700		D700

extern INT PVTXferProtocol;			// 000 = None		A800
extern INT PVTDataRecord;			// 000 = None		D800

extern INT haveProtocolArray;		// set to 1 if the GPS sends a protocol array

extern INT Protocols[55][12];
extern INT ProtocolIndex;			// index into above table which holds the valid
extern char outputdatum[150];
extern char inputdatum[150];
extern INT nameonly;     			// Handles comment and symbol display options
extern BYTE *SerialMessage;
extern BYTE *SerialMessageOut;
extern BYTE *message;
extern short SerialMsgLen;
//=====================================================================
// File names
//
extern char	*fname_in_all;	 		// current input file
extern char	*fname_out_all;			// current output file
extern char	*os;
//
// File Stream designators
//
extern FILE	*in;
extern FILE	*out;
extern FILE	*trks_out;				// used when sending internal track rcords to a file
extern FILE	*Gdebug_out;			// send serial debug info to this file

extern double	UTMa, UTMf;			// Used in conversion to UTM
extern INT SendLowrInactives;		// set to 1 if inactive waypoints are not to be sent
extern INT to_lowr_track;			// 0,1,2 for 'normal' or to track1 or track2
extern long	port_speed;				// Serial port baud rate
extern long via;					// set to 1 if point is a 'Via' in sa6
extern INT		default_Garmin_icon;// default icon used in icon type conversion
extern INT		default_G12_icon;
extern INT		default_SA5_icon;
extern INT		default_GM2_icon;
extern INT		default_SA52_icon;
extern INT		default_LWR_icon;
extern INT		Gdebug;					// ==1, record input & output RS232
extern char    outfmt[10];				// holds protocol output format
extern long	interval;					// used in get position command
extern INT		Garmin_NAKS_Sent;		// number of NAKs sent to Garmin GPS this session
extern INT		Lowr_NAKS_Sent;			// number of NAKs sent to Lowrance GPS this session
extern unsigned char recordtype;		// record type being sent
extern unsigned INT valid_records;		// number of valid records from input file
extern double	minlat,maxlat;			// min/max latitude.  SA4 Center of map calc
extern double  minlon,maxlon;			// min/max longitude.  SA4 Center of map calc
extern double  NoProximity;				// number of proximity waypoints found
extern INT		proximity;				// processing a proximity waypoint
extern INT		doAsyncStat;			// if 1 print stats from rs232 port
extern INT		new_com;				// if 1 a new com port has been input
extern INT		no_N;					// set to 0 if a 'N' record is read
extern INT		total_dist;				// flag to total distance of track line
extern double	track_d;				// distance of current track segment
extern double	sum_dist;				// total distance of all track segments
extern INT		satnum;					// satellite number for doAlmanac
extern INT		COMtimeout;				// Set to 1 on a receiver timeout
extern INT		PVTvar;					// used in getting PVT data
extern INT		sa_fileout;				// 1 if any output file has suffix .sa(3/4/5)
//
// SA output drawing options
//
extern INT		draw_route_1_19_obj;	// if 1 route waypoints are plotted on sa output
extern INT		draw_route_0;			// if 1 route 0 is drawn in sa4 output
extern INT		draw_route_0_obj;		// if 1 route 0 waypoints are plotted on sa4 output
extern INT		draw_track_lines;		// if 1 track lines are plotted on sa output
extern INT		draw_route_0_line;		// if the output is to an SA5 file lines are drawn
                            			// for route 0
extern INT		draw_route_1_19_lines;	// if 1 draw lines between route points
										//  in routes 1-19 when output is SA4
extern INT		draw_prox_circles;		// if 1 prox waypoints are plotted on sa output
extern INT		draw_waypoints;			// if 1 waypoints are plotted on sa output

extern INT		route_lines;			// Number of lines needed to draw routes
extern INT 		route_pushed;			// set to 1 when a route 0-19 is read
										//  from a SA file

extern INT		gotID;					// set to 1 when the connected GPS has been
										//  ID'd
extern unsigned	INT maxtrkptrs;			// maximum no of track points
extern unsigned	INT maxiconptrs;		// maximum no of icons
//
// used in resending last message
//
extern BYTE 	*LastLowrGPSMsg;
extern BYTE 	*LastGarminGPSMsg;
extern short	LastLowrLen;
extern short	LastGarminLen;
//
// Global variables
//
extern int		UTM;					// Set to one if output is to be UTM
extern INT		dataread;				// Set to 1 when data is read from a GPS
extern char		*Text;					// Used in 'pushing' items
extern INT		route0;					// nth point in route 0
extern INT		Sused;					// Sxxxxx already used up to here
extern long		ZeroL;					// a long 0
extern char		*infiles[20];			// array of input files
extern INT		current_in;				// index into infiles[] for current file
extern INT		input_files;			// number of input files
extern INT		in_file;				// file system file input found
extern char		*outfiles[20];			// array of output files
extern INT		output_files;			// number of output files
extern char		**waypoint_push;		// array of pointer to save waypoints
extern int		waypoints;				// Number of waypoints read into memory
extern char		**track_push;			// array of pointer to save track waypoints
extern char		**icon_push;			// array of pointer to save track waypoints
extern unsigned INT tracks;				// Number of track entries pushed into memory
extern unsigned INT icons;				// Number of icon entries pushed into memory
extern char 	**proximity_push;		// array of pointer to save proximity
extern INT		proximityp;				// Number of proximity waypoints read
extern INT		next_is_new;			// set to 1 when a 'N' record is read
										// and set to 0 when a 'T' record is read

extern INT 		*routeXpts;				// # of waypoints in route number 'x' is
										//    held in routeXpts[x]
extern char		*route_push[MAXROUTES+1][MAXPOINTS+1];// array of pointers to save route
extern INT		routes;					// Number of route points in route 1-> MAXROUTE
extern char		*route_comment;			// route name of current route 
extern INT		route_number;			// route number of current route
extern INT		route_points;			// route number of current route
extern INT		route_point;			// point number in current route
extern char		*routename1;			// used in sa3 -> text for routes
extern INT		in_route;				// set to 1 if reading a route
extern char		rtn[4];					// ASCII of current route number
extern INT		in_track;				// set to 1 if reading a track
extern INT		first_track;			// set to 1 if outputting first track point
										//  after an 'N' record
extern INT		first_track_push;		// pushing the first track
extern INT		first_icon_push;		// pushing the first icon
extern INT		first_waypoint_push;	// pushing the first waypoint
extern INT		first_proximity_push;	// pushing the first proximity waypoint
extern INT		trk_seg;				// number of track segments read
extern INT		*trks;					// elements in xth track seg
extern INT		cur_trk;				// track element currently being read
extern INT		nosort;					//  if 0 waypoints are sorted on input

extern INT 		symb;					// 1 = reading SA Symbol
										// 2 = reading SA Line
										// 3 = reading SA Circle
extern INT		mapCir;					// number of circles read from map

extern char		*drive;					// used by fnsplit
extern char		*dir;					// used by fnsplit
extern char		*file;					// used by fnsplit
extern char		*ext;					// used by fnsplit
extern INT		flags;					// used by fnsplit

extern INT		opterr ;				// argument expansion variable
extern INT		optind ;				// argument expansion variable
extern INT		optopt;					// argument expansion variable
extern char		*optarg;				// argument expansion variable

extern INT		IOaddr;					// COM port I/O address
extern INT		IRQnumber;				// COM port IRQ
extern INT		nocmdline;				// set to 1 if sa3->text is to have
										//   command lines

extern INT		firstR;					// used in nav.exe route processing
extern INT		firstW;					// used in nav.exe route processing

extern INT		input;					// we have valid input to process
extern INT		output;					// we have valid output	to process

extern INT		pwr;					// power off to GPS flag
extern INT		light;					// Backlight on (1) off (0)
extern INT		contrast_val;			// Set Contrast value
extern double  InternalVolts;			// Internal (AA) voltage returned by Garmin
extern double  ExternalVolts;			// External voltage returned by Garmin

/*
 * Structures
 */

extern INT	two;
extern INT	ObjCode;
extern double	setlat;
extern double	setlon;
extern double	lastlat;
extern double	lastlon;

extern INT	setmag;

extern INT 	Last_ObjSize;
extern INT 	Last_ObjColor;
extern INT 	Last_TextSize;
extern INT 	Last_TextColor;
extern INT 	Last_TextAlign;

extern INT 	Last_LineColor;
extern INT 	Last_LineWidth;
extern INT 	Last_LineStyle;

extern INT		Last_CirLineDraw;
extern INT		Last_CirFillArea;
extern INT		Last_CirLineColor;
extern INT		Last_CirLineWidth;
extern INT 	Last_CirFillColor;
extern INT 	Last_CirFillStyle;

//
// 
extern char LowrProducts[20][17];
extern char days[7][4];
extern char months[13][4];

extern unsigned char *genConst;
//===================================================================
extern INT		LowrType;		// 1=Track 1,  2=Track 2, 3=Waypoints
								// 4=Routes,   5=Icons

extern INT		g45type;		// 1=Tracks,  2=Waypoints, 3=Routes
								// 4=iD,      5=tIme,      6=Position
								// 7=Almanac, 8=proXimity waypoints 
								// 9=Voltages 10=Light on, 11=Light off

extern INT intype;				// 	1=txt/gd7 		2=GARMIN GPS i/o 3=SA3
								//  4=almanac data	5=Navigate route 6=SA4
								//  7=unused        8=SA gpl file    9=CSV
								// 10=Fugawi wpt   11=Fugawi track	12=OZI_OWP
								// 13=             14=               5=LOWRANCE GPS i/o
								// 99=GERROR

extern long	numrecords;			// number of input records in file
extern unsigned INT s4o_trk_recs;  // number of line objects in SA4 file
extern INT 	firstwaypoint;
extern INT 	firstPwaypoint;
extern INT 	firsttrackpoint;


extern char	*p;					// general pointer for string functions
extern char	*buf;				// general string

extern unsigned long LatConst;
extern unsigned long LonConst;
extern double	LatC,LonC;

extern INT	sa3number;  		// number of 'items' written to a SA file 
extern INT	Id,
		MagC,
		Mapfeatures;

extern char	*MapTitle;

extern INT	nameonlytxt0;
extern INT	nameonly0; 	// Handles comment and symbol display options
						
						// 0  - all items written
						// 1  - comment not written on regular waypoints
						// 2  - comment not written on route waypoints
						// 4  - the symbol display  parameter not written
						// 8  - route name is not written on first route point

extern INT	noname;		// 1 = no text info is output into SA files
extern INT	ShowGrids, NumObjs;
extern INT	ObjColor,TextColor,TextSize,ObjSize,TextAlign;
extern INT	LineWidth,LineColor,LineStyle;
extern INT	Route_LineWidth,Route_LineColor,Route_LineStyle;

extern INT	CirLineWidth,CirLineColor,CirFillStyle;
extern INT	CirLineDraw,CirFillArea,CirFillColor;

extern INT	ItemType,
		Item;

extern unsigned char MtLen;
extern unsigned long Const1;

extern BYTE	*bin;
extern INT	optchar;
extern INT	navmode,		// 1 = navigate.exe output
    	tmode,				// 1 = text output desired
    	g6,	 				// 1 = garmin64 output
    	s3o,				// 1 = output is sa3 file
		s4o,				// 1 = output is sa4 file
    	s5o,				// 1 = output is sa5 file
    	s6o,				// 1 = output is sa6 file
		gpl_out,			// 1 = output is to SA .gpl file
		csv_out,			// 1 = output is a comma separated file
		getGarminDisp,		// 1 = output GPS III/SP display to a file
		DisplayIsLowrance,	// if set to 1 then Lowrance display is output to .bmp
							//   instead of a Garmin Display
		oziwpt,				// 1 = output is a OziExplorer Saved wpt file
		ozievt,				// 1 = output is a OziExplorer Exported wpt file
		oziplt,				// 1 = output is a Ozi track (plot) file
		ozirte,				// 1 = output is a Ozi route file
		fugawiwpt,			// 1 = output is a FUGAWI wpt file
		fugawitrk,			// 1 = output is a FUGAWI trk file
		igctrackout,	  	// 1 = output is "B" record in an IGC file
		waypoint2trk;		// 1 = output waypoints as a track file

extern INT Lwrout;          // set to 1 is a lowrance unit is one of the outputs
extern INT G45out;          // set to 1 is a Garmin unit is one of the outputs
extern char align[8][3];
extern char sizes[5][3];
extern char colors[5][7];
extern char width[5][3];
extern char style[3][3];
extern char noyes[2][2];
extern INT Isat;  
extern void writeroute(void);
extern void write_mt_waypoints(void);
extern INT routepoint;
extern INT  SPWptNo;
extern BYTE *StreetPilotWptName;
extern BYTE *StreetPilotLnk_ident;
extern BYTE StreetPilotclass;

extern unsigned INT SWVersion;
extern INT ok;
extern char *Text;
extern INT proximity;
extern BYTE	p1[]	; // "\x06\x02\x1b\x00";	// Get 1st packet
extern BYTE	p2[]	; // "\x06\x02\x0c\x00";	// Get last packet
extern BYTE	rte2[]	; // "\x06\x02\x1d\x00";	// Get next route packet
extern BYTE	alm2[]	; // "\x06\x02\x1f\x00";	// Get next almanac packet
extern BYTE	trk2[]	; // "\x06\x02\x22\x00";	// Get next track packet
extern BYTE	wpt2[]	; // "\x06\x02\x23\x00";	// Get next waypoint packet
extern BYTE	ack1[]	; // "\x06\x02\xff\x00";	// ack for received mod/ver info

extern BYTE	Gabort[]; // "\x0a\x02\x00\x00";	// Abort Transfer
extern BYTE	alm1[]	; // "\x0a\x02\x01\x00";	// Send almanac
extern BYTE	GPSPos[]; // "\x0a\x02\x02\x00";	// send position
extern BYTE	pwpt1[]	; // "\x0a\x02\x03\x00";	// send Proximity waypoints
extern BYTE	rte1[]	; // "\x0a\x02\x04\x00";	// send routes
extern BYTE	display[];// "\x0a\x02\x20\x00";	// send gps III display
extern BYTE	GPStime[];// "\x0a\x02\x05\x00";	// send UTC time
extern BYTE	trk1[]	; // "\x0a\x02\x06\x00";	// send tracks
extern BYTE	wpt1[]	; // "\x0a\x02\x07\x00";	// send waypoints
extern BYTE	pwroff[]; // "\x0a\x02\x08\x00";	// Power off command
extern BYTE	VoltsM[]; // "\x0a\x02\x11\x00";	// send voltages
extern BYTE	PVTon[] ; // "\x0a\x02\x31\x00";	// start sending PVT records
extern BYTE	PVToff[]; // "\x0a\x02\x32\x00";	// stop sending PVT records

extern BYTE	almt[]	; // "\x0c\x02\x01\x00";	// Almanac data base terminator
extern BYTE	prxt[]	; // "\x0c\x02\x03\x00";	// Proximity data base terminator
extern BYTE	rtet[]	; // "\x0c\x02\x04\x00";	// Route data base terminator
extern BYTE	trkt[]	; // "\x0c\x02\x06\x00";	// Track data base terminator
extern BYTE	wptt[]	; // "\x0c\x02\x07\x00";	// Waypoint data base terminator

extern BYTE	nak1[]	; // "\x15\x02\xff\x00";	// nak for received mod/ver info

extern BYTE	bgnxfr[]; // "\x1b\x02\x00\x00";   // 0000 filled in with number

extern BYTE	lighton[]; //  "\x0f\x01\x00";		// send light on (some units)
extern BYTE	lightoff[]; // "\x0f\x01\x01";		// send light off (some units)
extern BYTE	lightiiP[]; // "\x0f\x01\x80";		// send light on II+
extern BYTE	contrast[]; // "\x0b\x01\x08";		// set contrast
extern BYTE	m1[]	  ; // "\xfe\x01\x20";		// Get the model and version number
extern INT VersionSubStrings;
extern char VersionString[99];  /* model/version in string format    */
extern char *VersionSubString[10];// version substrings
extern BYTE newTrack;  		/* 255 no track records this session */
extern INT	AlmanacEOF;
extern INT	RouteEOF;
extern INT	TrackEOF;
extern INT	ProxWaypointEOF;
extern INT	ProxWaypointEOF;
extern INT	WaypointEOF;
extern INT	WinNT;
extern unsigned INT len;               // misc length param
